Range Restriction in Angular DateRangePicker

25 Sep 20266 minutes to read

Range selection in a Angular DateRangePicker can be made-to-order with desire restrictions based on application needs.

Restrict the range within a range

You can restrict the minimum and maximum date that can be allowed as start date, end date in a range selection with help of min, max properties.

  • min – sets the minimum date that can be selected as startDate.
  • max – sets the maximum date that can be selected as endDate

In below sample, you can select a range from 15th day of this month to 15th day of next month.

import { NgModule } from '@angular/core'
import { FormsModule } from '@angular/forms'
import { BrowserModule } from '@angular/platform-browser'
import { DateRangePickerModule } from '@syncfusion/ej2-angular-calendars'




import { Component } from '@angular/core';

@Component({
imports: [
        
        FormsModule,
        DateRangePickerModule
    ],


standalone: true,
    selector: 'app-root',
    styleUrls: ['./index.css'],
    template: `<ejs-daterangepicker [min]='minDate' [max]='maxDate' placeholder='Select a range'></ejs-daterangepicker>`
})
export class AppComponent {
    public today: Date = new Date();
    public currentYear: number = this.today.getFullYear();
    public currentMonth: number = this.today.getMonth();
    public currentDay: number = this.today.getDate();
    public minDate: Object = new Date(this.currentYear, this.currentMonth, 15);
    public maxDate: Object =  new Date(this.currentYear, this.currentMonth+1, 15);
     constructor() {
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

 If the value of min or max properties changed through code behind, then you have to update the start date, end date property to set within the range. Or else , if the start and end date is out of specified date range, a validation error class will be appended to the input element. If strictMode is enabled, and both the start, end date is lesser than the min date then start and end date will be updated with min date. If both the start and end date is higher than the max date then start and end date will be updated with max date. Or else, if startDate is less than min date, startDate will be updated with min date or if endDate is greater than max date, endDate will be updated with the max date.

Range span

Span between ranges can be limited in order to avoid excess or less days selection towards the required days in a range.
In this, minimum and maximum span that can be allowed within the date range can be customized by minDays, maxDays properties.

  • minDays- Sets the minimum number of days between start date and end date.
  • maxDays- Sets the maximum number of days between start date and end date.
    In below sample, the range selection should be greater than 3 days and less than 8 days else it won’t set.
import { NgModule } from '@angular/core'
import { FormsModule } from '@angular/forms'
import { BrowserModule } from '@angular/platform-browser'
import { DateRangePickerModule } from '@syncfusion/ej2-angular-calendars'




import { Component } from '@angular/core';

@Component({
imports: [
        
        FormsModule,
        DateRangePickerModule
    ],


standalone: true,
    selector: 'app-root',
    styleUrls: ['./index.css'],
    template: `<ejs-daterangepicker [minDays]='minDays' [maxDays]='maxDays' placeholder='Select a range'></ejs-daterangepicker>`
})
export class AppComponent {
    public minDays: Number = 4;
    public maxDays: Number = 7;
     constructor() {
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Strict mode

DateRangePicker provides the option to limit the user towards entering the valid date only.
With strict mode, you can set only valid selection. Also, If any invalid range is specified then the date range value will reset to previous value.
This restriction can be availed by enabling the strictMode property.

import { NgModule } from '@angular/core'
import { FormsModule } from '@angular/forms'
import { BrowserModule } from '@angular/platform-browser'
import { DateRangePickerModule } from '@syncfusion/ej2-angular-calendars'




import { Component } from '@angular/core';

@Component({
imports: [
        
        FormsModule,
        DateRangePickerModule
    ],


standalone: true,
    selector: 'app-root',
    styleUrls: ['./index.css'],
    template: `<ejs-daterangepicker strictMode='true' placeholder='Select a range'></ejs-daterangepicker>`
})
export class AppComponent {
    constructor() {
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Range Restriction in React DateRangePicker

04 Sep 202611 minutes to read

Range selection in the React DateRangePicker can be customized with specific restrictions based on application requirements.

Restrict the range within a range

The min and max properties restrict the allowable date range:

  • min – Sets the minimum date that can be selected as the start date
  • max – Sets the maximum date that can be selected as the end date

In the following sample, you can select a date range from 15th date of this month to 15th date of next month.

[Class-component]

// import the daterangepicker component
import { DateRangePickerComponent } from '@syncfusion/ej2-react-calendars';
import * as React from "react";
import * as ReactDOM from "react-dom";
export default class App extends React.Component {
    // creates a daterangepicker with min and max property
    minDate = new Date(new Date().getFullYear(), new Date().getMonth(), 15);
    maxDate = new Date(new Date().getFullYear(), new Date().getMonth() + 1, 15);
    render() {
        return <DateRangePickerComponent id="daterangepicker" placeholder='Select a range' min={this.minDate} max={this.maxDate}/>;
    }
}
;
ReactDOM.render(<App />, document.getElementById('element'));
// import the daterangepicker component
import { DateRangePickerComponent } from '@syncfusion/ej2-react-calendars';
import * as React from "react";
import * as ReactDOM from "react-dom";

export default class App extends React.Component<{}, {}> {

    // creates a daterangepicker with min and max property
    private minDate:Date= new Date(new Date().getFullYear(), new Date().getMonth(), 15);
    private  maxDate:Date= new Date(new Date().getFullYear(), new Date().getMonth()+1, 15);

    public render() {
        return <DateRangePickerComponent id="daterangepicker" placeholder='Select a range' min={this.minDate} max={this.maxDate} />
    }
};
ReactDOM.render(<App />, document.getElementById('element'));

[Functional-component]

// import the daterangepicker component
import { DateRangePickerComponent } from '@syncfusion/ej2-react-calendars';
import * as React from "react";
import * as ReactDOM from "react-dom";
function App() {
    // creates a daterangepicker with min and max property
    const minDate = new Date(new Date().getFullYear(), new Date().getMonth(), 15);
    const maxDate = new Date(new Date().getFullYear(), new Date().getMonth() + 1, 15);
    return <DateRangePickerComponent id="daterangepicker" placeholder='Select a range' min={minDate} max={maxDate}/>;
}
;
ReactDOM.render(<App />, document.getElementById('element'));

Important Behavior Notes:

When min or max properties change programmatically, update the start and end dates accordingly. If dates fall outside the specified range:

  • Without strict mode: An error class is applied to the input element to indicate validation failure
  • With strict mode enabled:
    • If both dates are less than min, both are adjusted to min
    • If both dates exceed max, both are adjusted to max
    • If only start date is below min, it is adjusted to min
    • If only end date exceeds max, it is adjusted to max

Range span

The number of days in a selected range can be restricted using minDays and maxDays properties. This ensures users select ranges within the acceptable number of days:

  • minDays – Sets the minimum number of days required between start and end dates
  • maxDays – Sets the maximum number of days allowed between start and end dates

In the following sample, the range selection should be greater than 3 days and less than 8 days else it won’t set.

[Class-component]

// import the daterangepicker component
import { DateRangePickerComponent } from '@syncfusion/ej2-react-calendars';
import * as React from "react";
import * as ReactDOM from "react-dom";
export default class App extends React.Component {
    render() {
        return (<DateRangePickerComponent id="daterangepicker" placeholder='Select a range' minDays={3} maxDays={7}/>);
    }
}
;
ReactDOM.render(<App />, document.getElementById('element'));
// import the daterangepicker component
import { DateRangePickerComponent } from '@syncfusion/ej2-react-calendars';
import * as React from "react";
import * as ReactDOM from "react-dom";

export default class App extends React.Component<{}, {}> {
    public render() {
        return (
        <DateRangePickerComponent id="daterangepicker" placeholder='Select a range' minDays={3} maxDays={7} />
        )
    }
};
ReactDOM.render(<App />, document.getElementById('element'));

[Functional-component]

// import the daterangepicker component
import { DateRangePickerComponent } from '@syncfusion/ej2-react-calendars';
import * as React from "react";
import * as ReactDOM from "react-dom";
function App() {
    return (<DateRangePickerComponent id="daterangepicker" placeholder='Select a range' minDays={3} maxDays={7}/>);
}
;
ReactDOM.render(<App />, document.getElementById('element'));
// import the daterangepicker component
import { DateRangePickerComponent } from '@syncfusion/ej2-react-calendars';
import * as React from "react";
import * as ReactDOM from "react-dom";

function App() {
    return (
        <DateRangePickerComponent id="daterangepicker" placeholder='Select a range' minDays={3} maxDays={7} />
    )
};
ReactDOM.render(<App />, document.getElementById('element'));

Strict mode

When strictMode is enabled, the React DateRangePicker validates that only valid date ranges within the specified constraints can be selected. If an invalid range is specified, the component reverts to the previously valid value. This mode ensures data integrity by preventing invalid selections.

[Class-component]

// import the daterangepicker component
import { DateRangePickerComponent } from '@syncfusion/ej2-react-calendars';
import * as React from "react";
import * as ReactDOM from "react-dom";
export default class App extends React.Component {
    render() {
        return <DateRangePickerComponent id="daterangepicker" placeholder='Select a range' strictMode={true}/>;
    }
}
;
ReactDOM.render(<App />, document.getElementById('element'));
// import the daterangepicker component
import { DateRangePickerComponent } from '@syncfusion/ej2-react-calendars';
import * as React from "react";
import * as ReactDOM from "react-dom";

export default class App extends React.Component<{}, {}> {
    public render() {
        return <DateRangePickerComponent id="daterangepicker" placeholder='Select a range' strictMode={true} />
    }
};
ReactDOM.render(<App />, document.getElementById('element'));

[Functional-component]

// import the daterangepicker component
import { DateRangePickerComponent } from '@syncfusion/ej2-react-calendars';
import * as React from "react";
import * as ReactDOM from "react-dom";
function App() {
    return <DateRangePickerComponent id="daterangepicker" placeholder='Select a range' strictMode={true}/>;
}
;
ReactDOM.render(<App />, document.getElementById('element'));
// import the daterangepicker component
import { DateRangePickerComponent } from '@syncfusion/ej2-react-calendars';
import * as React from "react";
import * as ReactDOM from "react-dom";

function App() {
    return <DateRangePickerComponent id="daterangepicker" placeholder='Select a range' strictMode={true} />
};
ReactDOM.render(<App />, document.getElementById('element'));